'use strict';

var path = require('path');
var fs = require('fs');

exports.handlers = {
	newDoclet: function newDoclet(e) {
		var meta = e.doclet.meta;
		var description = e.doclet.description;

		if (typeof description === 'string' && meta.path && meta.filename) {
			(function () {
				// Set sourceString
				var fileContent = fs.readFileSync(path.join(meta.path || '.', meta.filename), 'utf-8');

				// Set sourceLines
				var sourceString = '';
				for (var i = meta.range[0]; i < meta.range[1]; i += 1) {
					sourceString += fileContent[i];
				}
				var sourceLines = sourceString.split('\n');

				// Set commentsArr
				var commentsArr = [];
				sourceLines.forEach(function (sourceLine) {
					if (/^\s*\/\//.test(sourceLine)) {
						commentsArr.push(sourceLine.split('//')[1]);
					}
				});

				// Set new description if commentsArr is full
				if (commentsArr.length > 0) {
					description += '\n<br><br><b>Specs:</b>\n<ol>\n';
					for (var _i = 0; _i < commentsArr.length; _i += 1) {
						description += '<li>' + commentsArr[_i] + '</li>\n';
					}
					description += '</ol>';
				}

				e.doclet.description = description;
			})();
		}
	}
};